public Handle:Scoreboard_Menu (client)
{
	new Handle:menu = CreatePanel();
	new String:text[512];
	Format(text, sizeof(text), "%T", "Scoreboard Menu", client);
	SetPanelTitle(menu, text);

	new bFlipped = GameRules_GetProp("m_bAreTeamsFlipped");
	if (!bFlipped) Format(text, sizeof(text), "%T", "Scoreboard Campaign Total", client, TM_GetCampaignScore(0), TM_GetCampaignScore(1));
	else Format(text, sizeof(text), "%T", "Scoreboard Campaign Total", client, TM_GetCampaignScore(1), TM_GetCampaignScore(0));
	DrawPanelText(menu, text);
	for (new i = 0; i <= mapcounter; i++)
	{
		if (!bFlipped) Format(text, sizeof(text), "%T", "Scoreboard Values", client, i + 1, MapScores[i][0], MapScores[i][1]);
		else Format(text, sizeof(text), "%T", "Scoreboard Values", client, i + 1, MapScores[i][1], MapScores[i][0]);
		DrawPanelText(menu, text);
	}
	if (!bRoundOver)
	{
		Format(text, sizeof(text), "%T", "Close Menu", client);
		DrawPanelItem(menu, text);
	}

	return menu;
}

stock TM_GetCampaignScore(value)
{
	new count = 0;
	for (new i = 0; i <= mapcounter; i++)
	{
		count += MapScores[i][value];
	}
	return count;
}

public Scoreboard_Menu_Init (Handle:topmenu, MenuAction:action, client, param2)
{
	if (action == MenuAction_Select)
	{
		switch (param2)
		{
			case 1:
			{
				SendPanelToClientAndClose(Scoreboard_Menu(client), client, Scoreboard_Menu_Init, 1);
			}
		}
	}
	if (topmenu != INVALID_HANDLE)
	{
		CloseHandle(topmenu);
	}
}

public Handle:Gametypevote_panel (client)
{
	new Handle:menu = CreatePanel();
	new String:text[512];
	Format(text, sizeof(text), "%T", "Main Menu Title", client);
	SetPanelTitle(menu, text);

	Format(text, sizeof(text), "%T", "Gametype Vote Info", client, GameTypeVote);
	DrawPanelText(menu, text);
	
	Format(text, sizeof(text), "%T", "Vote Requirement", client, PlayerVoteFavour(), PlayerVoteRequirement(), VoteTimeRemaining);
	DrawPanelText(menu, text);

	Format(text, sizeof(text), "%T", "Vote Yes", client);
	DrawPanelItem(menu, text);
	Format(text, sizeof(text), "%T", "Vote No", client);
	DrawPanelItem(menu, text);

	return menu;
}

public Gametypevote_panel_init (Handle:topmenu, MenuAction:action, client, param2)
{
	if (action == MenuAction_Select)
	{
		switch (param2)
		{
			case 1:
			{
				VoteType[client] = 2;
				PrintToChat(client, "%T", "Yes Vote", client, white, blue);
			}
			case 2:
			{
				VoteType[client] = 1;
				PrintToChat(client, "%T", "No Vote", client, white, orange);
			}
		}
	}
	if (topmenu != INVALID_HANDLE)
	{
		CloseHandle(topmenu);
	}
}

public Handle:Top10Players (client)
{
	new Handle:menu = CreatePanel();
	new String:text[32 + MAX_NAME_LENGTH];
	Format(text, sizeof(text), "Top 10 Players Menu", client);
	SetPanelTitle(menu, text);

	for (new i = 0; i <= 9; i++)
	{
		Format(text, sizeof(text), "%d.) %s", i + 1, TopRankedPlayers[i]);
		DrawPanelText(menu, text);
	}
	Format(text, sizeof(text), "%T", "Previous Page", client);
	DrawPanelItem(menu, text);

	return menu;
}

public Top10Players_Init (Handle:topmenu, MenuAction:action, client, param2)
{
	if (action == MenuAction_Select)
	{
		switch (param2)
		{
			case 1:
			{
				SendPanelToClientAndClose(TeamManagerMenu(client), client, TeamManagerMenu_Init, MENU_TIME_FOREVER);
			}
		}
	}
}

public Handle:TeamManagerMenu (client)
{
	new Handle:menu = CreatePanel();
	new String:pct[32];
	Format(pct, sizeof(pct), "%");
	new String:text[512];
	Format(text, sizeof(text), "%T", "Main Menu Title", client);
	SetPanelTitle(menu, text);

	new count = GetTeamPlayers(TEAM_SPECTATOR);
	Format(text, sizeof(text), "%T", "Spectator Team", client, count);
	DrawPanelItem(menu, text);
	for (new i = 1; i <= MaxClients; i++)
	{
		if (!IsClientHuman(i) || GetClientTeam(i) != TEAM_SPECTATOR) continue;
		Format(text, sizeof(text), "(s) %N", i);
		DrawPanelText(menu, text);
	}
	count = GetTeamPlayers(TEAM_SURVIVORS);
	Format(text, sizeof(text), "%T", "Survivors Team", client, count, GetConVarInt(g_Survivors));
	DrawPanelItem(menu, text);
	for (new i = 1; i <= MaxClients; i++)
	{
		if (!IsClientActual(i) || GetClientTeam(i) != TEAM_SURVIVORS) continue;
		if (IsPlayerAlive(i) && !IsIncapacitated(i)) Format(text, sizeof(text), "(a) %N", i);
		else if (IsPlayerAlive(i) && IsIncapacitated(i)) Format(text, sizeof(text), "(i) %N", i);
		else if (!IsPlayerAlive(i)) Format(text, sizeof(text), "(d) %N", i);
		if (IsFakeClient(i)) Format(text, sizeof(text), "(b)%s", text);
		DrawPanelText(menu, text);
	}
	decl String:GameTypeCurrent2[128];
	GetConVarString(FindConVar("mp_gamemode"), GameTypeCurrent2, 128);
	if (StrEqual(GameTypeCurrent2, "versus"))
	{
		count = GetTeamPlayers(TEAM_INFECTED);
		Format(text, sizeof(text), "%T", "Infected Team", client, count, GetConVarInt(g_Infected));
		DrawPanelItem(menu, text);
		for (new i = 1; i <= MaxClients; i++)
		{
			if (!IsClientHuman(i) || GetClientTeam(i) != TEAM_INFECTED) continue;
			if (IsPlayerAlive(i) && !IsGhost(i)) Format(text, sizeof(text), "(a) %N", i);
			else if (IsPlayerAlive(i) && IsGhost(i)) Format(text, sizeof(text), "(g) %N", i);
			else if (!IsPlayerAlive(i)) Format(text, sizeof(text), "(d) %N", i);
			DrawPanelText(menu, text);
		}
	}
	new survivors = GetTeamPlayers(TEAM_SURVIVORS);
	new infected = GetTeamPlayers(TEAM_INFECTED);
	if (infected >= GetConVarInt(g_Infected) && survivors >= GetConVarInt(g_Survivors) && GetClientTeam(client) == TEAM_SPECTATOR)
	{
		if (IsReserve(client) || IsAdmin(client))
		{
			Format(text, sizeof(text), "%T", "Remove A Player To Rejoin", client);
			DrawPanelItem(menu, text);
		}
	}

	Format(text, sizeof(text), "%T", "View Server Rankings", client);
	DrawPanelItem(menu, text);

	return menu;
}

public TeamManagerMenu_Init (Handle:topmenu, MenuAction:action, client, param2)
{
	new survivors = 0;
	new infected = 0;
	new String:Name[MAX_NAME_LENGTH];
	if (IsClientHuman(client)) GetClientName(client, Name, sizeof(Name));
	if (action == MenuAction_Select)
	{
		switch (param2)
		{
			case 1:
			{
				if (GetClientTeam(client) != TEAM_SPECTATOR)
				{
					if (IsAdmin(client) || IsReserve(client) || GetConVarInt(g_Module_Teams_SpectatorAllowed) == 1)
					{
						JoinTargetTeam(client, TEAM_SPECTATOR);
						bAway[client] = true;
						PrintToChatAll("%t", "Player Joined Spectator Team", white, green, Name);
						//CheckTeams(client);
					}
					SendPanelToClientAndClose(TeamManagerMenu(client), client, TeamManagerMenu_Init, MENU_TIME_FOREVER);
				}
			}
			case 2:
			{
				if (GetClientTeam(client) != TEAM_SURVIVORS)
				{
					decl String:GameTypeCurrent2[128];
					GetConVarString(FindConVar("mp_gamemode"), GameTypeCurrent2, 128);
					survivors = GetTeamPlayers(TEAM_SURVIVORS);
					infected = GetTeamPlayers(TEAM_INFECTED);

					bAway[client] = false;
					if (infected < survivors + 1 && StrEqual(GameTypeCurrent2, "versus"))
					{
						PrintToChat(client, "%T", "Cannot Join Team", client);
						if (GetClientTeam(client) == TEAM_SPECTATOR)
						{
							// player tried to join survivor, but infected team needs more, and the player is a spectator, so assign them to the infected team.
							JoinTargetTeam(client, TEAM_INFECTED);
							PrintToChatAll("%t", "Player Joined Infected Team", white, orange, Name);
						}
					}
					else if (survivors < GetConVarInt(g_Survivors))
					{
						JoinTargetTeam(client, TEAM_SURVIVORS);
						PrintToChatAll("%t", "Player Joined Survivor Team", white, blue, Name);
					}
				}
				SendPanelToClientAndClose(TeamManagerMenu(client), client, TeamManagerMenu_Init, MENU_TIME_FOREVER);
			}
			case 3:
			{
				if (GetClientTeam(client) != TEAM_INFECTED)
				{
					decl String:GameTypeCurrent2[128];
					GetConVarString(FindConVar("mp_gamemode"), GameTypeCurrent2, 128);
					if (!StrEqual(GameTypeCurrent2, "versus"))
					{
						if (!bLoadAttempted[client])
						{
							bLoadAttempted[client] = true;
							LoadPlayerData(client);
						}
						SendPanelToClientAndClose(TeamManagerRankings(client), client, TeamManagerRankings_Init, MENU_TIME_FOREVER);
						return;
					}
					survivors = GetTeamPlayers(TEAM_SURVIVORS);
					infected = GetTeamPlayers(TEAM_INFECTED);

					bAway[client] = false;
					if (survivors < infected + 1)
					{
						PrintToChat(client, "%T", "Cannot Join Team", client);
						if (GetClientTeam(client) == TEAM_SPECTATOR)
						{
							JoinTargetTeam(client, TEAM_SURVIVORS);
							PrintToChatAll("%t", "Player Joined Survivor Team", white, blue, Name);
						}
					}
					else if (infected < GetConVarInt(g_Infected))
					{
						JoinTargetTeam(client, TEAM_INFECTED);
						PrintToChatAll("%t", "Player Joined Infected Team", white, orange, Name);
					}
				}
				SendPanelToClientAndClose(TeamManagerMenu(client), client, TeamManagerMenu_Init, MENU_TIME_FOREVER);
			}
			case 4:
			{
				survivors = GetTeamPlayers(TEAM_SURVIVORS);
				infected = GetTeamPlayers(TEAM_INFECTED);
				if (infected >= GetConVarInt(g_Infected) && survivors >= GetConVarInt(g_Survivors) && GetClientTeam(client) == TEAM_SPECTATOR)
				{
					if (IsReserve(client) || IsAdmin(client))
					{
						// Remove a random non-reserve, non-admin from the game to make room for the player.
						new team = FreePlayerSlot(client);
						if (team == 3) JoinTargetTeam(client, TEAM_INFECTED);
						else if (team == 2) JoinTargetTeam(client, TEAM_SURVIVORS);
					}
				}
				else
				{
					if (!bLoadAttempted[client])
					{
						bLoadAttempted[client] = true;
						LoadPlayerData(client);
					}
					SendPanelToClientAndClose(TeamManagerRankings(client), client, TeamManagerRankings_Init, MENU_TIME_FOREVER);
				}
			}
			case 5:
			{
				survivors = GetTeamPlayers(TEAM_SURVIVORS);
				infected = GetTeamPlayers(TEAM_INFECTED);
				if (infected >= GetConVarInt(g_Infected) && survivors >= GetConVarInt(g_Survivors) && GetClientTeam(client) == TEAM_SPECTATOR)
				{
					if (!bLoadAttempted[client])
					{
						bLoadAttempted[client] = true;
						LoadPlayerData(client);
					}
					SendPanelToClientAndClose(TeamManagerRankings(client), client, TeamManagerRankings_Init, MENU_TIME_FOREVER);
				}
			}
		}
	}
	if (topmenu != INVALID_HANDLE)
	{
		CloseHandle(topmenu);
	}
}

public FreePlayerSlot(client)
{
	new count = 0;
	new team = 0;
	new String:Name[MAX_NAME_LENGTH];
	new String:ClientName[MAX_NAME_LENGTH];
	while (count < MaxClients)
	{
		new i = GetRandomInt(1, MaxClients);
		if (IsClientHuman(i) && GetClientTeam(i) != TEAM_SPECTATOR && !IsAdmin(i) && !IsReserve(i))
		{
			i = GetClientOfUserId(i);
			team = GetClientTeam(i);
			GetClientName(i, Name, sizeof(Name));
			GetClientName(client, ClientName, sizeof(ClientName));
			PrintToChatAll("%t", "Removed Due To Slot Reservation", orange, Name, white, blue, ClientName, white);
			KickClient(i, "Removed so reserved player %N could rejoin.", ClientName);			
			return team;
		}
		count++;
	}
	return 0;
}

public Handle:TeamManagerRankings (client)
{
	new Handle:menu = CreatePanel();
	new String:pct[32];
	Format(pct, sizeof(pct), "%");
	new String:text[512];
	Format(text, sizeof(text), "%T", "Main Menu Title", client);
	SetPanelTitle(menu, text);

	Format(text, sizeof(text), "___________");
	DrawPanelText(menu, text);
	Format(text, sizeof(text), "%T", "Common Kills Rank", client, AddCommasToString(CommonKills[client]), AddCommasToString(CommonKillsAverage[client]), CommonRank[client], CommonKillsAverageRank[client]);
	DrawPanelText(menu, text);
	Format(text, sizeof(text), "%T", "Special Kills Rank", client, AddCommasToString(SpecialKills[client]), SpecialRank[client]);
	DrawPanelText(menu, text);
	Format(text, sizeof(text), "%T", "Survivor Damage Rank", client, AddCommasToString(SurvivorDamage[client]), AddCommasToString(SurvivorDamageAverage[client]), SurvivorDamageRank[client], SurvivorDamageAverageRank[client]);
	DrawPanelText(menu, text);
	Format(text, sizeof(text), "%T", "Survivor Rescues Rank", client, AddCommasToString(Rescues[client]));
	DrawPanelText(menu, text);
	Format(text, sizeof(text), "%T", "Survivor Incaps Rank", client, AddCommasToString(SurvivorIncaps[client]));
	DrawPanelText(menu, text);
	Format(text, sizeof(text), "%T", "Infected Damage Rank", client, AddCommasToString(InfectedDamage[client]), AddCommasToString(InfectedDamageAverage[client]), InfectedDamageRank[client], InfectedDamageAverageRank[client]);
	DrawPanelText(menu, text);
	Format(text, sizeof(text), "%T", "Infected Incaps Rank", client, AddCommasToString(InfectedIncaps[client]));
	DrawPanelText(menu, text);
	Format(text, sizeof(text), "%T", "Rank Display", client, Rank[client], RankMaximum);
	DrawPanelText(menu, text);
	Format(text, sizeof(text), "%T", "Macrogongon", client);
	DrawPanelText(menu, text);

	Format(text, sizeof(text), "%T", "Previous Page", client);
	DrawPanelItem(menu, text);

	return menu;
}

public TeamManagerRankings_Init (Handle:topmenu, MenuAction:action, client, param2)
{
	if (action == MenuAction_Select)
	{
		switch (param2)
		{
			case 1:
			{
				SendPanelToClientAndClose(TeamManagerMenu(client), client, TeamManagerMenu_Init, MENU_TIME_FOREVER);
			}
		}
	}
	if (topmenu != INVALID_HANDLE)
	{
		CloseHandle(topmenu);
	}
}

public Action:Timer_JoinSurvivorTeam(Handle:timer, any:client)
{
	if (!IsClientHuman(client)) return Plugin_Stop;
	JoinTargetTeam(client, TEAM_SURVIVORS);
	return Plugin_Stop;
}

public GetTop10()
{
	decl String:TQuery[1024];
	Format(TQuery, sizeof(TQuery), "SELECT `Name` FROM `rankings` ORDER BY `RankAvg` ASC LIMIT 10;");
	SQL_TQuery(hDatabase, GetTop10Query, TQuery);
}

public GetClientRank(client)
{
	decl String:TQuery[1024];
	Format(TQuery, sizeof(TQuery), "SELECT COUNT(*) FROM `rankings`");
	SQL_TQuery(hDatabase, SendRankMaximumQuery, TQuery);

	if (SurvivorRoundsPlayed[client] > 0)
	{
		if (CommonKills[client] > 0) CommonKillsAverage[client] = CommonKills[client] / SurvivorRoundsPlayed[client];
		if (SurvivorDamage[client] > 0) SurvivorDamageAverage[client] = SurvivorDamage[client] / SurvivorRoundsPlayed[client];
	}
	if (InfectedRoundsPlayed[client] > 0)
	{
		if (InfectedDamage[client] > 0) InfectedDamageAverage[client] = InfectedDamage[client] / InfectedRoundsPlayed[client];
	}
	
	Format(TQuery, sizeof(TQuery), "SELECT COUNT(*) FROM `rankings` WHERE (`CK` > '%i');", CommonKills[client]);
	SQL_TQuery(hDatabase, SendCommonsQuery, TQuery, client);
	if (CommonKillsAverage[client] > 0)
	{
		Format(TQuery, sizeof(TQuery), "SELECT COUNT(*) FROM `rankings` WHERE (`CKA` > '%i');", CommonKillsAverage[client]);
		SQL_TQuery(hDatabase, SendCommonsAverageQuery, TQuery, client);
	}
	else CommonKillsAverageRank[client] = RankMaximum;

	Format(TQuery, sizeof(TQuery), "SELECT COUNT(*) FROM `rankings` WHERE (`SK` > '%i');", SpecialKills[client]);
	SQL_TQuery(hDatabase, SendSpecialQuery, TQuery, client);

	Format(TQuery, sizeof(TQuery), "SELECT COUNT(*) FROM `rankings` WHERE (`SD` > '%i');", SurvivorDamage[client]);
	SQL_TQuery(hDatabase, SendSDamageQuery, TQuery, client);
	if (SurvivorDamageAverage[client] > 0)
	{
		Format(TQuery, sizeof(TQuery), "SELECT COUNT(*) FROM `rankings` WHERE (`SDA` > '%i');", SurvivorDamageAverage[client]);
		SQL_TQuery(hDatabase, SendSDamageAverageQuery, TQuery, client);
	}
	else SurvivorDamageAverageRank[client] = RankMaximum;
	
	Format(TQuery, sizeof(TQuery), "SELECT COUNT(*) FROM `rankings` WHERE (`ID` > '%i');", InfectedDamage[client]);
	SQL_TQuery(hDatabase, SendIDamageQuery, TQuery, client);
	if (InfectedDamageAverage[client] > 0)
	{
		Format(TQuery, sizeof(TQuery), "SELECT COUNT(*) FROM `rankings` WHERE (`IDA` > '%i');", InfectedDamageAverage[client]);
		SQL_TQuery(hDatabase, SendIDamageAverageQuery, TQuery, client);
	}
	else InfectedDamageAverageRank[client] = RankMaximum;

	Rank[client] = (CommonRank[client] + SpecialRank[client] + SurvivorDamageRank[client] + InfectedDamageRank[client] + 
	CommonKillsAverageRank[client] + SurvivorDamageAverageRank[client] + InfectedDamageAverageRank[client]) / 7;

	if (Rank[client] < 1) Rank[client] = RankMaximum;
}

public FindHumanCount()
{
	new count = 0;
	for (new i = 1; i <= MaxClients; i++)
	{
		if (!IsClientHuman(i)) continue;
		count++;
	}
	return count;
}

stock MakeATeamDecision(client)
{
	if (!bAway[client])
	{
		if (!IsVersus()) JoinTargetTeam(client, TEAM_SURVIVORS);
		else if (IsVersus() && bRoundOver)	//	Players are still connecting
		{
			new bool:IsFlipped = false;
			if (GameRules_GetProp("m_bAreTeamsFlipped")) IsFlipped = true;

			if (TM_GetCampaignScore(0) != TM_GetCampaignScore(1))
			{
				if (!IsFlipped && Team[client] == TM_GetCampaignScore(0) || IsFlipped && Team[client] == TM_GetCampaignScore(1)) JoinTargetTeam(client, TEAM_SURVIVORS);
				else JoinTargetTeam(client, TEAM_INFECTED);
			}
			else if (Team[client] > 0) JoinTargetTeam(client, Team[client]);
			else JoinTargetTeam(client, 0);
		}
		else if (IsVersus() && !bRoundOver)	//	Game is currently in progress
		{
			JoinTargetTeam(client, FindNewPlayerTeam(client));
		}
	}
}

stock IsTeamCountUnbalanced(bool:IsLessPlayers)
{
	if (GetTeamPlayers(TEAM_INFECTED) > GetTeamPlayers(TEAM_SURVIVORS) + 1)
	{
		if (!IsLessPlayers) return TEAM_INFECTED;
		else return TEAM_SURVIVORS;
	}
	else if (GetTeamPlayers(TEAM_INFECTED) + 1 < GetTeamPlayers(TEAM_SURVIVORS))
	{
		if (!IsLessPlayers) return TEAM_SURVIVORS;
		else return TEAM_INFECTED;
	}
	return 0;
}

stock FindNewPlayerTeam(client)
{
	if (!IsVersus()) return TEAM_SURVIVORS;
	if (GetTeamPlayers(TEAM_INFECTED) == GetTeamPlayers(TEAM_SURVIVORS)) return GetRandomInt(2, 3);
	if (GetTeamPlayers(TEAM_INFECTED) > GetTeamPlayers(TEAM_SURVIVORS)) return TEAM_SURVIVORS;
	return TEAM_INFECTED;
}

stock bool:IsValidTeamPlayers(TeamNumber)
{
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientHuman(i) && GetClientTeam(i) == TeamNumber && (TeamNumber == 2 || FindZombieClass(i) != ZOMBIECLASS_TANK)) return true;
	}
	return false;
}

stock bool:IsValidTeamPlayersAtRank(TeamNumber, value)
{
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientHuman(i) && GetClientTeam(i) == TeamNumber && (TeamNumber == 2 || FindZombieClass(i) != ZOMBIECLASS_TANK) && Rank[i] == value) return true;
	}
	return false;
}

stock JoinTargetTeam(client, TeamNumber)
{
	if (!IsClientHuman(client))
	{
		LogToFile(LOGFILE, "JoinTargetTeam failed: Client is not human.");
		return;
	}
	if (TeamNumber == 0) TeamNumber = FindNewPlayerTeam(client);
	if (GetClientTeam(client) != TeamNumber)
	{
		if (TeamNumber == TEAM_INFECTED) ChangeClientTeam(client, 3);
		else if (TeamNumber == TEAM_SURVIVORS)
		{
			new bot		=	FindSurvivorBot();
			HumanReplaceSurvivorBot(client, bot);
		}
		else if (TeamNumber == TEAM_SPECTATOR)
		{
			//if (GetClientTeam(client) == TEAM_SURVIVORS)
			ChangeClientTeam(client, 1);
		}
		if (TeamNumber != TEAM_SURVIVORS) CreateTimer(1.0, Timer_KickSurvivorBot, _, TIMER_FLAG_NO_MAPCHANGE);
	}
}

stock SurvivorCheck()
{
	if (IsScramble) return;
	IsSurvivorCheck = true;
	for (new i = ActualSurvivorCount(); i < GetConVarInt(g_Survivors_MinimumRequired); i++) { HumanReplaceSurvivorBot(-1, -1); }
	CreateTimer(1.0, Timer_SurvivorCheck, _, TIMER_FLAG_NO_MAPCHANGE);
}

public Action:Timer_SurvivorCheck(Handle:timer)
{
	IsSurvivorCheck = false;
	return Plugin_Stop;
}

stock ActualSurvivorCount()
{
	new count = 0;
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientActual(i) && GetClientTeam(i) == TEAM_SURVIVORS) count++;
	}
	if (GetConVarInt(g_Survivors_BotsRequireHumans) == 1 && !AnyHumanPlayers()) return GetConVarInt(g_Survivors_MinimumRequired) + 1;
	return count;
}

stock bool:AnyHumanPlayers()
{
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientHuman(i) && GetClientTeam(i) != TEAM_SPECTATOR) return true;
	}
	return false;
}

stock KickSurvivorBots()
{
	if (IsKickingBots || bTransition || IsScramble || bRoundOver) return;
	if (ActualSurvivorCount() <= GetConVarInt(g_Survivors_MinimumRequired))
	{
		if (!IsSurvivorCheck) SurvivorCheck();
		return;
	}
	IsKickingBots = true;
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientActual(i) && GetClientTeam(i) == TEAM_SURVIVORS && IsFakeClient(i)) KickClient(i);
	}
	IsKickingBots = false;
}

public Action:Timer_KickSurvivorBot(Handle:timer)
{
	if (!bRoundOver && !IsKickingBots) KickSurvivorBots();
	return Plugin_Stop;
}

stock bool:IsL4D2Campaign()
{
	decl String:MapName[128];
	GetCurrentMap(MapName, sizeof(MapName));
	if (StrContains(MapName, "c1m", false) > -1 ||
	StrContains(MapName, "c2m", false) > -1 ||
	StrContains(MapName, "c3m", false) > -1 ||
	StrContains(MapName, "c4m", false) > -1 ||
	StrContains(MapName, "c5m", false) > -1 ||
	StrContains(MapName, "c6m", false) > -1 ||
	StrContains(MapName, "c7m", false) > -1 ||
	StrContains(MapName, "c13m", false) > -1) return true;
	return false;
}

public Action:Timer_SetSurvivorModel(Handle:timer, any:client)
{
	if (IsClientActual(client)) FindAndSetSurvivorModel(client);
	return Plugin_Stop;
}

stock FindAndSetSurvivorModel(client)
{
	new String:Model[512];
	if (GetModelCount(client, NICK_MODEL) < 1) Format(Model, sizeof(Model), "%s", NICK_MODEL);
	else if (GetModelCount(client, ROCHELLE_MODEL) < 1) Format(Model, sizeof(Model), "%s", ROCHELLE_MODEL);
	else if (GetModelCount(client, COACH_MODEL) < 1) Format(Model, sizeof(Model), "%s", COACH_MODEL);
	else if (GetModelCount(client, ELLIS_MODEL) < 1) Format(Model, sizeof(Model), "%s", ELLIS_MODEL);
	else if (GetModelCount(client, ZOEY_MODEL) < 1) Format(Model, sizeof(Model), "%s", ZOEY_MODEL);
	else if (GetModelCount(client, FRANCIS_MODEL) < 1) Format(Model, sizeof(Model), "%s", FRANCIS_MODEL);
	else if (GetModelCount(client, LOUIS_MODEL) < 1) Format(Model, sizeof(Model), "%s", LOUIS_MODEL);
	else if (GetModelCount(client, NICK_MODEL) < 2) Format(Model, sizeof(Model), "%s", NICK_MODEL);
	else if (GetModelCount(client, ROCHELLE_MODEL) < 2) Format(Model, sizeof(Model), "%s", ROCHELLE_MODEL);
	else if (GetModelCount(client, COACH_MODEL) < 2) Format(Model, sizeof(Model), "%s", COACH_MODEL);
	else if (GetModelCount(client, ELLIS_MODEL) < 2) Format(Model, sizeof(Model), "%s", ELLIS_MODEL);
	else if (GetModelCount(client, ZOEY_MODEL) < 2) Format(Model, sizeof(Model), "%s", ZOEY_MODEL);
	else if (GetModelCount(client, FRANCIS_MODEL) < 2) Format(Model, sizeof(Model), "%s", FRANCIS_MODEL);
	else if (GetModelCount(client, LOUIS_MODEL) < 2) Format(Model, sizeof(Model), "%s", LOUIS_MODEL);
	else
	{
		new number	=	GetRandomInt(1, 7);
		if (number == 1) Format(Model, sizeof(Model), "%s", NICK_MODEL);
		else if (number == 2) Format(Model, sizeof(Model), "%s", ROCHELLE_MODEL);
		else if (number == 3) Format(Model, sizeof(Model), "%s", COACH_MODEL);
		else if (number == 4) Format(Model, sizeof(Model), "%s", ELLIS_MODEL);
		else if (number == 5) Format(Model, sizeof(Model), "%s", ZOEY_MODEL);
		else if (number == 6) Format(Model, sizeof(Model), "%s", FRANCIS_MODEL);
		else if (number == 7) Format(Model, sizeof(Model), "%s", LOUIS_MODEL);
	}
	if (StrEqual(Model, NICK_MODEL))
	{
		SetEntProp(client, Prop_Send, "m_survivorCharacter", NICK_NET);
		SetEntityModel(client, NICK_MODEL);
	}
	else if (StrEqual(Model, ROCHELLE_MODEL))
	{
		SetEntProp(client, Prop_Send, "m_survivorCharacter", ROCHELLE_NET);
		SetEntityModel(client, ROCHELLE_MODEL);
	}
	else if (StrEqual(Model, COACH_MODEL))
	{
		SetEntProp(client, Prop_Send, "m_survivorCharacter", COACH_NET);
		SetEntityModel(client, COACH_MODEL);
	}
	else if (StrEqual(Model, ELLIS_MODEL))
	{
		SetEntProp(client, Prop_Send, "m_survivorCharacter", ELLIS_NET);
		SetEntityModel(client, ELLIS_MODEL);
	}
	else if (StrEqual(Model, ZOEY_MODEL))
	{
		SetEntProp(client, Prop_Send, "m_survivorCharacter", ZOEY_NET);
		SetEntityModel(client, ZOEY_MODEL);
	}
	else if (StrEqual(Model, FRANCIS_MODEL))
	{
		SetEntProp(client, Prop_Send, "m_survivorCharacter", FRANCIS_NET);
		SetEntityModel(client, FRANCIS_MODEL);
	}
	else if (StrEqual(Model, LOUIS_MODEL))
	{
		SetEntProp(client, Prop_Send, "m_survivorCharacter", LOUIS_NET);
		SetEntityModel(client, LOUIS_MODEL);
	}
	if (!HasPrimaryWeapon(client) && IsPlayerAlive(client))// && !bRoundOver)
	{
		new WeaponNumber		=	GetRandomInt(1, 2);
		L4D_RemoveWeaponSlot(client, L4DWeaponSlot_Primary);
		if (WeaponNumber == 1) ExecCheatCommand(client, "give", "pumpshotgun");
		else if (WeaponNumber == 2) ExecCheatCommand(client, "give", "smg");
		//L4D_RemoveWeaponSlot(client, L4DWeaponSlot_Secondary);
		ExecCheatCommand(client, "give", "pistol_magnum");
	}
}

stock bool:HasPrimaryWeapon(client)
{
	new weaponIndex = GetPlayerWeaponSlot(client, 0);
	if (weaponIndex != -1) return true;
	return false;
}

stock GetModelCount(client, String:Model[])
{
	new count = 0;
	new String:TModel[512];
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientHuman(i) && GetClientTeam(i) == TEAM_SURVIVORS)
		{
			GetClientModel(i, TModel, sizeof(TModel));
			if (StrEqual(TModel, Model)) count++;
		}
	}
	return count;
}

stock HumanReplaceSurvivorBot(client, target)
{
	if (target > 0)
	{
		SDKCall(hSetHumanSpec, target, client);
		SDKCall(hTakeOverBot, client, true);
		if (IsL4D2Campaign()) CreateTimer(1.0, Timer_SetSurvivorModel, client, TIMER_FLAG_NO_MAPCHANGE);
	}
	else
	{
		new bot		=	CreateFakeClient("Bot");
		if (IsValidEntity(bot))
		{
			ChangeClientTeam(bot, TEAM_SURVIVORS);
			if (DispatchKeyValue(bot, "classname", "survivorbot") && DispatchSpawn(bot))
			{
				new Float:Location[3];
				for (new i = 1; i <= MaxClients; i++)
				{
					if (IsClientActual(i) && GetClientTeam(i) == TEAM_SURVIVORS && i != bot)
					{
						GetClientAbsOrigin(i, Location);
						TeleportEntity(bot, Location, NULL_VECTOR, NULL_VECTOR);
						break;
					}
				}

				if (IsClientActual(bot) && GetClientTeam(bot) == TEAM_SURVIVORS) KickClient(bot);
				CreateTimer(1.0, Timer_JoinSurvivorTeam, client, TIMER_FLAG_NO_MAPCHANGE);
			}
		}
	}
}

stock FindSurvivorBot()
{
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientActual(i) && GetClientTeam(i) == TEAM_SURVIVORS && IsFakeClient(i)) return i;
	}
	return 0;
}

public TeamAssignmentCheck(bool:NewMap)
{
	if (GetConVarInt(g_Module_Teams_MaintainTeams) == 0) return;
	LastScramble++;
	//bTeamsFlipped = !!GameRules_GetProp("m_bAreTeamsFlipped", 4, 0);
	if (GameRules_GetProp("m_bAreTeamsFlipped")) bTeamsFlipped = true;
	else bTeamsFlipped = false;
	if (GetConVarInt(g_Debug) == 1)
	{
		if (bTeamsFlipped) PrintToChatAll("teams are flipped.");
		else PrintToChatAll("teams are not flipped.");
	}
	if (NewMap)
	{
		for (new i = 1; i <= MaxClients; i++)
		{
			if (!IsClientHuman(i)) continue;
			if (bAway[i]) continue;			// player is away, so leave them in spectator.
			// We only set team assignments if it wasn't a tie game. In the case of it being a tie, it keeps the players in their respective teams.
			if (TM_GetCampaignScore(0) != TM_GetCampaignScore(1))
			{
				if (Team[i] != TM_GetCampaignScore(1) && 
					Team[i] != TM_GetCampaignScore(0))
				{
					// Had to be a spectator or a new player...
					Team[i] = 0;	// so we know to skip them.
					continue;
				}
				// Use this method, instead
				if (!bTeamsFlipped && Team[i] == TM_GetCampaignScore(0) || 
					bTeamsFlipped && Team[i] == TM_GetCampaignScore(1)) Team[i] = 2;
				else Team[i] = 3;
			}
			if (GetClientTeam(i) == TEAM_SURVIVORS && Team[i] == 3 || 
				GetClientTeam(i) == TEAM_INFECTED && Team[i] == 2) JoinTargetTeam(i, TEAM_SPECTATOR);
			else Team[i] = 0;		// player is on their proper team, so ignore.
		}
		for (new i = 1; i <= MaxClients; i++)
		{
			if (!IsClientHuman(i) || Team[i] == 0) continue;
			CreateTimer(0.2, Timer_TeamCorrection, i, TIMER_FLAG_NO_MAPCHANGE);
		}
		if (IsVersus()) AutoTeamBalancer();		// I'm running this check in case, after players are placed back on their teams at the start of a non-scramble eligible map, if we need to move players around.
	}
	else
	{
		for (new i = 1; i <= MaxClients; i++)
		{
			if (!IsClientHuman(i)) continue;
			if (GetClientTeam(i) == TEAM_SPECTATOR)
			{
				Team[i] = -1;
				bAway[i] = true;
				continue;
			}
			bAway[i] = false;
			if (TM_GetCampaignScore(0) != TM_GetCampaignScore(1))
			{
				if (GetClientTeam(i) == TEAM_SURVIVORS && !bTeamsFlipped) Team[i] = TM_GetCampaignScore(0);
				else if (GetClientTeam(i) == TEAM_SURVIVORS && bTeamsFlipped) Team[i] = TM_GetCampaignScore(1);
				else if (GetClientTeam(i) == TEAM_INFECTED && !bTeamsFlipped) Team[i] = TM_GetCampaignScore(1);
				else if (GetClientTeam(i) == TEAM_INFECTED && bTeamsFlipped) Team[i] = TM_GetCampaignScore(0);
			}
			else
			{
				// If the teams are tied, players stay on their current side.
				if (GetClientTeam(i) == TEAM_SURVIVORS) Team[i] = 2;
				else if (GetClientTeam(i) == TEAM_INFECTED) Team[i] = 3;
			}
		}
	}
}

public Action:Timer_TeamCorrection(Handle:timer, any:client)
{
	if (!IsClientHuman(client)) return Plugin_Stop;
	if (Team[client] == TEAM_SURVIVORS)
	{
		JoinTargetTeam(client, TEAM_SURVIVORS);
	}
	else if (Team[client] == TEAM_INFECTED)
	{
		JoinTargetTeam(client, TEAM_INFECTED);
	}
	return Plugin_Stop;
}

public Action:CMD_SwapPlayer(client, args)
{
	if (args < 2)
	{
		PrintToChat(client, "[STK] Usage: !swap (player | userid) (team no)");
		return Plugin_Handled;
	}
	decl String:arg[MAX_NAME_LENGTH], String:arg2[4];
	GetCmdArg(1, arg, sizeof(arg));
	if (args > 1)
	{
		GetCmdArg(2, arg2, sizeof(arg2));
	}
	decl String:target_name[MAX_TARGET_LENGTH];
	decl target_list[MAXPLAYERS], target_count, bool:tn_is_ml;
	new targetclient;
	if ((target_count = ProcessTargetString(
			arg,
			client,
			target_list,
			MAXPLAYERS,
			COMMAND_FILTER_CONNECTED,
			target_name,
			sizeof(target_name),
			tn_is_ml)) > 0)
	{
		for (new i = 0; i < target_count; i++) targetclient = target_list[i];
		decl String:Name[MAX_NAME_LENGTH];
		GetClientName(targetclient, Name, sizeof(Name));
		if (StringToInt(arg2) == 2)
		{
			PrintToChatAll("%t", "Player Joined Survivor Team", white, blue, Name);
			if (IsClientHuman(client))
			{
				JoinTargetTeam(targetclient, TEAM_SURVIVORS);
			}
		}
		else if (StringToInt(arg2) == 3)
		{
			PrintToChatAll("%t", "Player Joined Infected Team", white, orange, Name);
			if (IsClientHuman(client)) JoinTargetTeam(targetclient, TEAM_INFECTED);
		}
		else if (StringToInt(arg2) == 1)
		{
			PrintToChatAll("%t", "Player Joined Spectator Team", white, green, Name);
			if (IsClientHuman(client)) JoinTargetTeam(targetclient, TEAM_SPECTATOR);
		}
		if (StringToInt(arg2) >= 1 && StringToInt(arg2) <= 3) bAway[targetclient] = false;
	}
	return Plugin_Handled;
}

stock String:AddCommasToString(value) 
{
	new String:buffer[128];
	new String:separator[1];
	separator = ",";
	buffer[0] = '\0'; 
	new divisor = 1000; 
	
	while (value >= 1000 || value <= -1000)
	{
		new offcut = value % divisor;
		value = RoundToFloor(float(value) / float(divisor));
		Format(buffer, sizeof(buffer), "%s%03.d%s", separator, offcut, buffer); 
	}
	
	Format(buffer, sizeof(buffer), "%d%s", value, buffer);
	return buffer;
}